

#include "allstuff.h"


CTexture *font_tex = NULL;

struct tCharDescr {
	float width;
	float s0,t0,s1,t1;
};


tCharDescr chars[128];


void hud_print(char *s,float x,float y,float h)
{
	if(!font_tex) return;
	
	if(x==-2) x=-0.5*hud_text_length(s,h);
	if(x== 2) x=1-hud_text_length(s,h);

	font_tex->Bind(0);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_COLOR,GL_ONE_MINUS_SRC_COLOR);
	glBegin(GL_QUADS);
	float w;
	y-=h;
	while(*s)
	{
		if(*s<33 || *s>126)
			x+=2*chars['i'].width*h;
		else
		{
			w=chars[*s].width*h;
			glTexCoord2f(chars[*s].s0,chars[*s].t1); glVertex3f(x  ,y  ,0);
			glTexCoord2f(chars[*s].s0,chars[*s].t0); glVertex3f(x  ,y+h,0);
			glTexCoord2f(chars[*s].s1,chars[*s].t0); glVertex3f(x+w,y+h,0);
			glTexCoord2f(chars[*s].s1,chars[*s].t1); glVertex3f(x+w,y  ,0);
			x+=w;
		}
		s++;
	}
	glEnd();
	glDisable(GL_BLEND);
	font_tex->UnBind(0);
}

float hud_text_length(char *s,float h)
{
	if(!font_tex) return 0;
	float w,x=0;
	while(*s)
	{
		if(*s<33 || *s>126)
			x+=2*chars['i'].width*h;
		else
		{
			w=chars[*s].width*h;
			x+=w;
		}
		s++;
	}
	return x;
}

void init_hud()
{
	font_tex = load_texture("celtic");
	
	FILE *fp = fopen("data/celtic.xml","rt");
	if(!fp) return;
	char buff[1000];
	int id,x,y,w,h;
	while(fgets(buff,1000,fp))
	{
		id=0;
		sscanf(buff," <char id=\"%d\" x=\"%d\" y=\"%d\" width=\"%d\" height=\"%d\" />",
			&id,&x,&y,&w,&h);
//		printf("%d %d %d %d %d\n",id,x,y,w,h);
//		msg(("%d",id));
//		msg_once(("%d %d",w,h));
		if(id<33 || id>126)
			continue;

		chars[id].width = float(w)/h;

		chars[id].s0=(x-0.5)/256.0;
		chars[id].t0=(y-0.5)/256.0;
		chars[id].s1=(x+w+0.5)/256.0;
		chars[id].t1=(y+h+0.5)/256.0;
	}
	fclose(fp);

}

void deinit_hud()
{
	font_tex = NULL;
}

