

#include "allstuff.h"



void do_logic(float dt)
{
//	int mx,my;
//	get_mouse_mickeys(&mx,&my);
//	cam_ax -= float(mx)/SCREEN_W*100.0;
//	cam_ay += float(my)/SCREEN_W*100.0;

	if(!(key[KEY_TAB]||(mouse_b&2)))
	{
		float mx = float(mouse_x)/SCREEN_W*2-1.0;
		if(mx<-0.4) cam_ax-=(mx+0.4)/0.6*400*dt;
		if(mx> 0.4) cam_ax-=(mx-0.4)/0.6*400*dt;
		cam_ax = fmod(cam_ax,360.0);
	}
	
	float dx=0;
	float dy=0;
	
	if(key[KEY_W]) dx+=dt*2;
	if(key[KEY_S]) dx-=dt*2;
	if(key[KEY_A]) dy-=dt*2;
	if(key[KEY_D]) dy+=dt*2;
	if(key[KEY_R]) cam_pos.z+=dt*2;
	if(key[KEY_F]) cam_pos.z-=dt*2;
	
	cam_pos += vec3(cos(cam_ax/180.0*M_PI),sin(cam_ax/180.0*M_PI),0)*dx;
	cam_pos += vec3(sin(cam_ax/180.0*M_PI),-cos(cam_ax/180.0*M_PI),0)*dy;
}


int main()
{
	allegro_init();
	install_allegro_gl();
	install_timer();
	install_keyboard();
	install_mouse();
	
	set_color_depth(32);
	
	allegro_gl_set(AGL_COLOR_DEPTH, 32);
	allegro_gl_set(AGL_Z_DEPTH, 32);
	allegro_gl_set(AGL_SUGGEST, AGL_COLOR_DEPTH | AGL_Z_DEPTH);
	
	if(set_gfx_mode(GFX_OPENGL,1024,768,0,0)<0)
//	if(set_gfx_mode(GFX_OPENGL,320,240,0,0)<0)
	{
		allegro_message("Can't set up OpenGL.");
		return 0;
	}
	
	srand(time(0));
	
	init_engine();
	
	while(!key[KEY_SPACE] && !key[KEY_ESC])
	{
		glClearColor(0,0,0,0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		set_2d_mode();
		hud_print("DRUID",-2,0.9,0.3);
		hud_print("by Krzysztof Kluczek",-2,0.5,0.05);
		hud_print("Press space to start",-2,-0.2,0.1);
		allegro_gl_flip();
	}


	make_map(rand());
	
	cam_pos = vec3(0,0,2);

	long long freq,clk,_clk;
	int ndelta;
	float delta;
	
	QueryPerformanceFrequency((_LARGE_INTEGER*)&freq);
	QueryPerformanceCounter((_LARGE_INTEGER*)&clk);
	_clk=clk;
	
//	CMesh *m = load_mesh("druid",0.005);
	int i,f,m1=0,m2=20;
	float t=0;

	while(!key[KEY_ESC] && !(player_obj && player_obj->health<=0))
	{
		cam_follow_player();
		set_3d_mode();
		glClearColor(0,0,0,0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		render_map();
		render_parts();

//		glRotatef(t*60,0,0,1);
/*		f=int(t/0.025)%(2*(m2-m1));
		if(f+m1<=m2) f=f+m1;
		else f=m2-(f+m1-m2);
		render_mesh(m,f);*/
			
		set_2d_mode();
		show_spells();
		draw_mouse();
//		hud_print("DRUID",-1,0,0.4);
			
		allegro_gl_flip();

		QueryPerformanceCounter((_LARGE_INTEGER*)&clk);
		delta = float(clk-_clk)/freq;
		t+=delta;
		_clk = clk;
		
		ndelta = int(ceil(delta/0.1));
		if(ndelta<=0) ndelta = 1;
		delta /= ndelta;
		
		if(ndelta>10) ndelta=10;

		while(ndelta-->0)
		{
			do_logic(delta);
			think_parts(delta);
			player_think(delta);
			think_objects(delta);
//			add_parts(part_type("fire"),vec3(2*sin(t/0.5),0,1),vec3(0,0,0.0),0.03,0,1);
		}
		
		if(map.end_x==int(player_obj->pos.x) && map.end_y==int(player_obj->pos.y))
		{
			level_complete = false;
			make_map(rand());
			level++;
		}
	}
	
	if(player_obj && player_obj->health<=0)
	{
		while(!key[KEY_SPACE] && !key[KEY_ESC])
		{
			glClearColor(0,0,0,0);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			set_2d_mode();
			hud_print("Game over",-2,0.7,0.2);
			char buff[100];
			sprintf(buff,"Your score: %d",score);
			hud_print(buff,-2,0.2,0.1);
			hud_print("Press space to exit",-2,-0.2,0.1);
			allegro_gl_flip();
		}
	}
	
	deinit_engine();
	
	return 0;
}
END_OF_MAIN()

