

#include "allstuff.h"



#define S_FIRE		0
#define S_COLD		1
#define S_ACID		2



char s_name[100];
int s_id;
float s_damage,s_speed,s_castspd,s_mana,s_type;
float s_spread,s_random;
int s_count;



char *it_fire[6]={"flame","fires","heat","fireball","sun","blast"};
char *it_cold[6]={"frost","colds","snows","spike"};
char *it_acid[6]={"acid","venom","poison","clouds"};



int spells[MAX_SPELLS];
int act_spell;



char *rand_subname()
{
	static char b[4];
	b[0]="xthrwqplknmbz"[rand()%13];
	b[1]="auioey"[rand()%6];
	if(rand()%2) b[2]="xthrwqplknmbz"[rand()%13];
	else b[2]=0;
	b[3]=0;
	return b;
}

char *rand_name()
{
	static char b[30],a1[4],a2[4],a3[4];
	strcpy(a1,rand_subname());
	strcpy(a2,rand_subname());
	strcpy(a3,rand_subname());
	int r=rand()%9;
	a1[0]-=32;
	if(r==0) sprintf(b,"%s",a1);
	if(r==1) sprintf(b,"%s%s",a1,a2);
	if(r==2) sprintf(b,"%s%s%s",a1,a2,a3);
	if(r==3) a2[0]-=32, sprintf(b,"%s-%s",a1,a2);
	if(r==4) a2[0]-=32, sprintf(b,"%s-%s%s",a1,a2,a3);
	if(r==5) a3[0]-=32, sprintf(b,"%s%s-%s",a1,a2,a3);
	if(r==6) a2[0]-=32, sprintf(b,"%s'%s",a1,a2);
	if(r==7) a2[0]-=32, sprintf(b,"%s'%s%s",a1,a2,a3);
	if(r==8) a3[0]-=32, sprintf(b,"%s%s'%s",a1,a2,a3);
	return b;
}

void decode_spell(int id)
{
	int rnd=rand();
	srand(id);
	
	s_id=id;
	int r=rand()%10;
	if(r<5)			s_type=S_FIRE;
	else if(r<8)	s_type=S_COLD;
	else			s_type=S_ACID;

//	s_damage = 1+((rand()%5)*(rand()%5)*(rand()%5))/5;
	s_speed = (50+rand()%100)*0.03;
	s_castspd = 0.05*50/(50+(rand()%13)*(rand()%13));
	s_random = (rand()%100)<70;
	s_mana = (10+rand()%10);
	
	r=rand()%100;
	if(r<50) s_count=1;
	else if(r<75) s_count=2;
	else if(r<85) s_count=3;
	else if(r<90) s_count=4;
	else s_count=1+rand()%9;

	r=rand()%100;
	if(r<50) s_damage=1;
	else if(r<75) s_damage=2;
	else if(r<85) s_damage=3;
	else if(r<90) s_damage=4;
	else s_damage=1+rand()%9;
	s_damage*=1+rand()%3;

	s_count = 1+(rand()%10)*(rand()%10)/10;
	s_spread = (rand()%100)/100.0/s_count;

	char *it="";
	if(s_type==S_FIRE) it=it_fire[rand()%6];
	if(s_type==S_COLD) it=it_cold[rand()%4];
	if(s_type==S_ACID) it=it_acid[rand()%4];

	if(rand()%2) sprintf(s_name,"%s of %s",it,rand_name());
	else sprintf(s_name,"%s's %s",rand_name(),it);
	if(s_name[0]>='a') s_name[0]-=32;

	srand(rnd);
}


void spell_think(tObject *o)
{
	o->flags |= FL_DELETED;
}

void spell_collide(tObject *o)
{
	o->flags |= FL_DELETED;
	
	if(col_object)
	{
		decode_spell(o->spell);
		if(o->owner==player_obj)
		{
			if(s_type==S_FIRE) s_damage*=col_object->r-0.3;
			if(s_type==S_ACID) s_damage*=col_object->g-0.3;
			if(s_type==S_COLD) s_damage*=col_object->b-0.3;
			col_object->health -= s_damage;
		}
		else
		{
			if(col_object==player_obj)
				col_object->health -= s_damage*(10+level)*0.1;
		}
	}
}

void launch_spell_single(vec3 pos,float head,tObject *owner)
{
	tObject *o = create_object();
	o->pos = pos;
	head+=90;
	o->vel = vec3(cos(head/180.0*M_PI),sin(head/180.0*M_PI),0)*s_speed;
	o->think_func = spell_think;
	o->col_func = spell_collide;
	o->owner = owner;
	o->spell = s_id;
	
	if(s_type==S_FIRE) o->ptype = part_type("sfire"), o->light_color=vec3(1.0,1.0,0.3);
	if(s_type==S_COLD) o->ptype = part_type("scold"), o->light_color=vec3(0.3,1.0,1.0);
	if(s_type==S_ACID) o->ptype = part_type("sacid"), o->light_color=vec3(0.3,1.0,0.3);
	
	o->flags = FL_EMIT | FL_NO_COLLISION | FL_LIGHT | FL_TRIGGER | FL_FAST_EMIT;
	o->pscale = s_damage;
	o->ppr = o->pscale*0.002;
	o->pvr = 0;
	o->think_time = 1;

	update_object(o);
}

void launch_spell(vec3 pos,float head,int id,tObject *owner)
{
	decode_spell(id);
	head-=(s_count-1)/2*s_spread*60;
	head+=(rand()%201-100)/100.0*s_random*30;
	int i=0;
	for(i=0;i<s_count;i++)
	{
		launch_spell_single(pos,head,owner);
		head+=s_spread*60;
	}
}


void player_obj_think(tObject *o)
{
	if(o->state==S_RUN)
	{
		if(o->frame<=21) { o->frame=21; o->state2=0; }
		if(o->frame>=30) { o->frame=30; o->state2=1; }
		o->frame+=(o->state2)?-1:1;

		o->think_time=0.03;
	}

	if(o->state==S_ATTACK)
	{
		if(o->frame<1 || o->frame>20) { o->frame=1; o->state2=0; }
		if(o->frame==20)
		{
			launch_spell(o->pos+vec3(0,0,0.15),o->heading,o->spell,o);
			o->state2=1;
		}
		if(o->frame<=10 && o->state2 && mouse_b) { o->frame=10; o->state2=0; }
		if(o->frame<=1 && o->state2) { o->state = S_RUN; }

		o->frame+=(o->state2)?-1:1;

		o->think_time=o->adelay;
	}
	
	if(o->state==S_STAND)
	{
		o->frame=0;
		o->think_time=0.1;
	}
}

void player_think(float dt)
{
	static int _mb=0;
	int mb=mouse_b;
	
	player_obj->think_func = player_obj_think;
	
	decode_spell(spells[act_spell]);
	player_obj->adelay = s_castspd;

	vec3 v = (mouse_p0-player_obj->pos);
	v.z=0;
	v.normalize();
	
//	player_obj->vel = v*1.7*!!(mb&2);
	float newh = player_obj->heading;

	float dx=0;
	float dy=0;

	if(key[KEY_W]) dx+=1.2;
	if(key[KEY_S]) dx-=1.2;
	if(key[KEY_A]) dy-=1.2;
	if(key[KEY_D]) dy+=1.2;

	float h = cam_ax;//player_obj->heading+90;
	player_obj->vel  = vec3(cos(h/180.0*M_PI),sin(h/180.0*M_PI),0)*dx;
	player_obj->vel += vec3(sin(h/180.0*M_PI),-cos(h/180.0*M_PI),0)*dy;
	
	player_obj->health += dt;
	if(player_obj->health>100) player_obj->health=100;
	
	int nstate = S_STAND;
	if(dx||dy) { newh = atan2(-player_obj->vel.x,player_obj->vel.y)/M_PI*180.0; nstate = S_RUN; }
	if(mouse_b && !(key[KEY_TAB]||(mouse_b&2))) { newh=atan2(-v.x,v.y)/M_PI*180.0; nstate = S_ATTACK; }
	float dh=newh-player_obj->heading;
	if(dh<-180) dh+=360;
	if(dh> 180) dh-=360;

	player_obj->heading += dh*0.1;

	if(player_obj->state!=S_ATTACK)
	{
		player_obj->state=nstate;
		if(nstate==S_ATTACK)
			player_obj->spell = spells[act_spell];
	}

	_mb = mb;

}


extern vec3 cam_follow;

void spawn_player()
{
	if(!player_obj)
	{
		int i;
		for(i=0;i<MAX_SPELLS;i++)
			spells[i]=rand();
		act_spell=0;
	}

	tObject *o = create_object();
	player_obj = o;
	o->pos = vec3(map.start_x+0.5,map.start_y+0.5,0);
	o->mesh = load_mesh("druid",0.005);
	o->flags = FL_WALK;
	o->health = 100;
	update_object(o);

	cam_follow = o->pos;
	
	add_parts(part_type("exit"),o->pos,vec3(0,0,0.5),0.1,0.3,30,1);

	spawn_exit(map.end_x,map.end_y);
}

void show_spells()
{
	int i,mp;
	float xp= float(mouse_x)/SCREEN_W*2-1;
	float yp=-float(mouse_y)/SCREEN_H*2+1;
	if(xp>0) mp=-1;
	else		mp=int(floor((1-yp)/0.08));

	if(key[KEY_TAB]||(mouse_b&2))
	{
		if(mouse_b && mp>=0 && mp<MAX_SPELLS)
			act_spell=mp;

		for(i=0;i<MAX_SPELLS;i++)
		{
			if(i==act_spell)
				if(i==mp)	glColor4f(0.0,1.0,0.0,1.0);
				else		glColor4f(0.0,1.0,1.0,1.0);
			else
				if(i==mp)	glColor4f(0.8,0.8,0.8,1.0);
				else		glColor4f(0.0,0.0,0.8,1.0);

			decode_spell(spells[i]);
			hud_print(s_name,-1,1-i*0.08,0.08);
		}
	}
	else
	{
		glColor4f(1.0,1.0,1.0,1.0);

		decode_spell(spells[act_spell]);
		hud_print(s_name,-1,1,0.08);
	}
	
	glColor4f(1.0,1.0,1.0,1.0);
	char buff[40];
	sprintf(buff,"Level %d",level);
	hud_print(buff,2,1,0.08);
	sprintf(buff,"Health %d%%",int(floor(player_obj->health)));
	hud_print(buff,2,1-0.08,0.08);
	sprintf(buff,"Score %d",score);
	hud_print(buff,2,1-0.16,0.08);
}

