

#include "allstuff.h"


bool level_complete = false;
int level = 1;
int score = 0;


void think_torch(tObject *o)
{
	float v=(rand()%101)/100.0*0.8+0.2;

	o->light_color=(o->light_color+vec3(1.0,0.8,0.2)*v)*0.5;
	o->think_time=0.05;
}

void think_enemy(tObject *o)
{
	if(o->health<=0)
		o->state=S_DIE;


	if(o->state==S_RUN)
	{
		if(o->frame<1 || o->frame>=26) o->frame=1;
		else o->frame++;

		o->think_time=0.03;
	}
	if(o->state==S_ATTACK)
	{
		if(o->frame<27) o->frame=27;
		else if(o->frame>=33) o->frame=33;
		else o->frame++;

		o->think_time=0.1;
	}
	if(o->state==S_DIE)
	{
		if(o->frame<34) o->frame=34;
		else o->frame++;
		
		if(o->frame>44 && !(o->flags&FL_DELETED))
		{
			o->flags |= FL_DELETED;
			score += level+9;
		}

		o->think_time=0.05;
	}
	
	if(o->spell && rand()%100<3)
	{
		launch_spell(o->pos+vec3(0,0,0.15),o->heading,o->spell,o);
		o->think_time=1.0;
		o->vel=vec3(0,0,0);
		return;
	}
	
	o->state==S_RUN;
	vec3 v=player_obj->pos - o->pos;
	float le=v.length();
	float lm=fabs(v.x);
	if(fabs(v.y)>lm) lm=fabs(v.y);
	v.normalize();
	o->heading = atan2(-v.x,v.y)/M_PI*180.0;

	if(o->state==S_RUN)
	{
		float h = o->heading+90;
		o->vel  = vec3(cos(h/180.0*M_PI),sin(h/180.0*M_PI),0)*o->speed;
		
		if(lm<0.3) o->state=S_ATTACK;
	}
	else
	{
		o->vel  = vec3(0,0,0);
		if(o->frame==33)
		{
			o->state=S_RUN;
			if(lm<0.4)
				player_obj->health-=level+level*(rand()%101)/100.0;
		}
	}
}

void spawn_enemy(int tx,int ty)
{
	tObject *o = create_object();
	o->pos = vec3(tx+0.5,ty+0.5,0);
	o->mesh = load_mesh("enemy",0.005);
	o->flags = FL_WALK;
	o->think_func = think_enemy;
	o->state = S_RUN;
	
	o->speed  = 0.15+rand()%101/100.0*0.70;
	o->health = (1+rand()%101/100.0*10)*(level+9)/10.0;
	
	if(rand()%100<10+3*level)
		o->spell=rand();

	o->r = rand()%101/100.0;
	o->g = rand()%101/100.0;
	o->b = rand()%101/100.0;
	if(o->r<0.3) o->r=0.3;
	if(o->g<0.3) o->g=0.3;
	if(o->b<0.3) o->b=0.3;

	update_object(o);
}

void exit_collide(tObject *o)
{
//	level_complete = true;
}

void spawn_exit(int tx,int ty)
{
	tObject *o = create_object();
	o->pos = vec3(tx+0.5,ty+0.5,0.25);
	o->flags = FL_NO_COLLISION | FL_TRIGGER | FL_EMIT | FL_FAST_EMIT | FL_LIGHT;
	o->light_color = vec3(0,3,3);
	o->ptype = part_type("exit");
	o->pscale = 1;
	o->ppr = 0.10;
	o->pvr = 0.3;
	o->col_func = exit_collide;
	update_object(o);
}

void cloud_collide(tObject *o)
{
	if(col_object!=player_obj)
		return;
	o->flags|=FL_DELETED;
	spells[act_spell]=rand();
//	level_complete = true;
}

void spawn_cloud(int tx,int ty)
{
	tObject *o = create_object();
	o->pos = vec3(tx+0.5,ty+0.5,0.25);
	o->flags = FL_NO_COLLISION | FL_TRIGGER | FL_EMIT | FL_FAST_EMIT | FL_LIGHT;
	o->light_color = vec3(0,3,0);
	o->ptype = part_type("cloud");
	o->pscale = 1;
	o->ppr = 0.10;
	o->pvr = 0.3;
	o->col_func = cloud_collide;
	update_object(o);
}

